[Libguestfs] [PATCH nbdkit v5 FINAL 17/19] tests: offset: Add a test of extent handling in the offset filter.

Richard W.M. Jones rjones at redhat.com
Thu Mar 28 16:18:44 UTC 2019


---
 tests/Makefile.am            |  5 +-
 tests/test-offset-extents.sh | 99 ++++++++++++++++++++++++++++++++++++
 2 files changed, 103 insertions(+), 1 deletion(-)

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 64b2c45..75561b2 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -84,6 +84,7 @@ EXTRA_DIST = \
 	test_ocaml_plugin.ml \
 	test-ocaml.c \
 	test-offset2.sh \
+	test-offset-extents.sh \
 	test-parallel-file.sh \
 	test-parallel-nbd.sh \
 	test-partition1.sh \
@@ -863,7 +864,9 @@ test_offset_SOURCES = test-offset.c test.h
 test_offset_CFLAGS = $(WARNINGS_CFLAGS) $(LIBGUESTFS_CFLAGS)
 test_offset_LDADD = libtest.la $(LIBGUESTFS_LIBS)
 
-TESTS += test-offset2.sh
+TESTS += \
+	test-offset2.sh \
+	test-offset-extents.sh
 
 # partition filter test.
 TESTS += test-partition1.sh
diff --git a/tests/test-offset-extents.sh b/tests/test-offset-extents.sh
new file mode 100755
index 0000000..60fbb47
--- /dev/null
+++ b/tests/test-offset-extents.sh
@@ -0,0 +1,99 @@
+#!/usr/bin/env bash
+# nbdkit
+# Copyright (C) 2018-2019 Red Hat Inc.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are
+# met:
+#
+# * Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# * Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# * Neither the name of Red Hat nor the names of its contributors may be
+# used to endorse or promote products derived from this software without
+# specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY RED HAT AND CONTRIBUTORS ''AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
+# PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL RED HAT OR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+
+# Unfortunately the output of this test depends on the PAGE_SIZE
+# defined in common/sparse/sparse.c and would change (breaking the
+# test) if we ever changed that definition.
+
+source ./functions.sh
+set -e
+set -x
+
+requires jq --version
+requires qemu-img --version
+requires qemu-img map --help
+
+out="test-offset-extents.out"
+expected="test-offset-extents.expected"
+files="$out $expected"
+rm -f $files
+cleanup_fn rm -f $files
+
+do_test ()
+{
+    # We use jq to normalize the output and convert it to plain text.
+    nbdkit -U - \
+           --filter=offset \
+           data data="$1" size="$2" \
+           offset=1024 range=65536 \
+           --run 'qemu-img map -f raw --output=json $nbd' |
+        jq -c '.[] | {start:.start, length:.length, data:.data, zero:.zero}' \
+           > $out
+    if ! cmp $out $expected; then
+        echo "$0: output did not match expected data"
+        echo "expected:"
+        cat $expected
+        echo "output:"
+        cat $out
+        exit 1
+    fi
+}
+
+# Completely sparse disk.
+cat > $expected <<'EOF'
+{"start":0,"length":65536,"data":false,"zero":true}
+EOF
+do_test "" 1M
+
+# Completely allocated disk.
+#
+# We have to write a non-zero byte @32767 so that the sparse array
+# doesn't detect the range from 1024-32767 as being all zeroes.
+cat > $expected <<'EOF'
+{"start":0,"length":65536,"data":true,"zero":false}
+EOF
+do_test "1 @32767 1 @32768 1 @65536 1 @98304 1" 128K
+
+# Allocated data at the start of a 1M disk.
+cat > $expected <<'EOF'
+{"start":0,"length":31744,"data":true,"zero":false}
+{"start":31744,"length":33792,"data":false,"zero":true}
+EOF
+do_test "1 @32767 1" 1M
+
+# Allocated zeroes at the start of the disk.
+cat > $expected <<'EOF'
+{"start":0,"length":31744,"data":true,"zero":true}
+{"start":31744,"length":33792,"data":false,"zero":true}
+EOF
+do_test "0" 1M
-- 
2.20.1




More information about the Libguestfs mailing list